/*
 * Projet de lancer de rayons
 *
 * Jean-Guillaume Delculry
 *
 * STRUCTURES.H
 *
 */

class Luminosite
{
public:
	double Ir;
	double Ig;
	double Ib;

	Luminosite();
	void Init();
	Luminosite Add(Luminosite);
};


class Point  {
public:
	double x,y,z;

	Point();
	Point(double nx, double ny, double nz);
};


class Vecteur  {
public:
	double x,y,z;

	Vecteur();
	Vecteur(double nx, double ny, double nz);
	Vecteur(Point a, Point b);
	double pScalaire(Vecteur v);
	Vecteur pVectoriel(Vecteur v);
	double Norme();
	void Normaliser();
};


class Rayon  {
public:
	Point porig;
	Vecteur vdir;

	Rayon();
	Rayon(Point a, Vecteur v);
};


class Matrice  {
public:
	double a,b,c,d,e,f,g,h,i;

	Matrice();
	Matrice(Vecteur,Vecteur,Vecteur);
	Matrice Add(Matrice B);
	Point Mul(Point p);
};


class ObjetIntersection
{
public:
	double zmin;
	Point Pinter;
	Vecteur Vn;
	Point Couleur;
	int miroir;

	ObjetIntersection();
	void Init();
};


class Sphere
{
public:
	Point porig;
	double r;
	Point Couleur;
	int miroir;

	Sphere();
	Sphere(Point,int);
	Sphere(Point, double, Point,int);

	void Intersection(Rayon, ObjetIntersection &);
};


class Plan
{
public:
	Vecteur vnorm;
	double d;
	Point Couleur;
	int miroir;

	Plan();
	Plan(Point,int);
	Plan(Vecteur, double, Point,int);
	Plan(Point, double, Point,int);

	void Intersection(Rayon, ObjetIntersection &);
};



class Facette
{
public:
	Point A;
	Point B;
	Point C;
	Point Couleur;
	int miroir;
	Vecteur vnorm;
	// Pour la facette
	double d;
	
	Facette();
	Facette(Point,int);
	Facette(Point,Point,Point,Point,int);

	void Intersection(Rayon, ObjetIntersection &);
};


typedef struct  {
	int nl;
	int np;
	unsigned char* buffer;
}Image;



Matrice MatricePassage(Point, Point);
Image creerimage(int, int);
int ecrireimage(Image *, char *);
Luminosite Phong(Rayon Ray, ObjetIntersection &I, Point source);
